summaryrefslogtreecommitdiffstats
path: root/system
diff options
context:
space:
mode:
author Pierre-Philipp Braun2020-04-24 02:39:23 +0200
committer Willy Sudiarto Raharjo2020-04-24 02:39:23 +0200
commitbdd030c118c7dd5996113f9afa2f4ef7f8e1fd78 (patch)
tree352d6a0c1db8763b94e0464cbf6cfe14b89404e0 /system
parentde24fb3e8b1e63f3ba582fcffb57332ff5973d99 (diff)
downloadslackbuilds-bdd030c118c7dd5996113f9afa2f4ef7f8e1fd78.tar.gz
system/heartbeat: Added (Linux-HA heartbeat).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'system')
-rw-r--r--system/heartbeat/README13
-rw-r--r--system/heartbeat/doinst.sh27
-rw-r--r--system/heartbeat/heartbeat.SlackBuild121
-rw-r--r--system/heartbeat/heartbeat.info10
-rw-r--r--system/heartbeat/slack-desc19
5 files changed, 190 insertions, 0 deletions
diff --git a/system/heartbeat/README b/system/heartbeat/README
new file mode 100644
index 0000000000..742f8f2af6
--- /dev/null
+++ b/system/heartbeat/README
@@ -0,0 +1,13 @@
+Linux-HA heartbeat
+
+Heartbeat is a daemon that provides cluster infrastructure (communication and
+membership) services to its clients. This allows clients to know about the
+presence (or disappearance!) of peer processes on other machines and to easily
+exchange messages with them.
+
+Heartbeat still comes with an integrated primitive resource
+manager, which basically is just a shell script. This is also
+referred to as "v1 style" or "haresources style" configuration.
+
+You might also want to install cluster-glue, heartbeat, resource-agents,
+fence-agents.
diff --git a/system/heartbeat/doinst.sh b/system/heartbeat/doinst.sh
new file mode 100644
index 0000000000..bdba1fdb05
--- /dev/null
+++ b/system/heartbeat/doinst.sh
@@ -0,0 +1,27 @@
+config() {
+ NEW="$1"
+ OLD="`dirname $NEW`/`basename $NEW .new`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then # toss the redundant cop
+y
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname ${NEW})/$(basename ${NEW} .new)"
+ if [ -e ${OLD} ]; then
+ cp -a ${OLD} ${NEW}.incoming
+ cat ${NEW} > ${NEW}.incoming
+ mv ${NEW}.incoming ${NEW}
+ fi
+ config ${NEW}
+}
+
+config etc/ha.d/authkeys.new
+config etc/ha.d/ha.cf.new
+config etc/ha.d/haresources.new
+preserve_perms etc/init.d/heartbeat.new
diff --git a/system/heartbeat/heartbeat.SlackBuild b/system/heartbeat/heartbeat.SlackBuild
new file mode 100644
index 0000000000..1d481aeec7
--- /dev/null
+++ b/system/heartbeat/heartbeat.SlackBuild
@@ -0,0 +1,121 @@
+#!/bin/sh
+
+# Slackware build script for heartbeat
+
+# Copyright 2018 Pierre-Philipp Braun, Russia
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=heartbeat
+VERSION=${VERSION:-20200423}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+./bootstrap
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --disable-dependency-tracking \
+ --build=$ARCH-slackware-linux \
+ --disable-rpath
+
+make
+make install DESTDIR=$PKG
+mv $PKG/etc/rc.d/init.d/heartbeat $PKG/etc/rc.d/init.d/heartbeat.new
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+#/etc/init.d/heartbeat script is already deployed by make install
+
+#/etc/ha.d/ folder is already created by make install, adding sample configs
+cat doc/authkeys > $PKG/etc/ha.d/authkeys.new
+cat doc/ha.cf > $PKG/etc/ha.d/ha.cf.new
+cat doc/haresources > $PKG/etc/ha.d/haresources.new
+chmod 600 $PKG/etc/ha.d/authkeys.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ README \
+ $PKG/usr/doc/$PRGNAM-$VERSION/README.heartbeat
+doc=`find doc/ -type f | grep -vE '.([[:digit:]]|in|am|am.orig)$'`
+cp -a \
+ $doc \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+unset doc
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/heartbeat/heartbeat.info b/system/heartbeat/heartbeat.info
new file mode 100644
index 0000000000..a4160d6635
--- /dev/null
+++ b/system/heartbeat/heartbeat.info
@@ -0,0 +1,10 @@
+PRGNAM="heartbeat"
+VERSION="20200423"
+HOMEPAGE="https://github.com/pbraun9/heartbeat"
+DOWNLOAD="https://github.com/pbraun9/heartbeat/archive/20200423/heartbeat-20200423.tar.gz"
+MD5SUM="740fab2aea67f98e4c411af35dccec0b"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="cluster-glue resource-agents"
+MAINTAINER="Pierre-Philipp Braun"
+EMAIL="pbraun@nethence.com"
diff --git a/system/heartbeat/slack-desc b/system/heartbeat/slack-desc
new file mode 100644
index 0000000000..9649a4fb6d
--- /dev/null
+++ b/system/heartbeat/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+heartbeat: heartbeat (Linux-HA heartbeat)
+heartbeat:
+heartbeat: Old school cluster infrastructure for GNU/Linux
+heartbeat: Allows you to avoid Corosync and even Pacemaker
+heartbeat:
+heartbeat: No CRMSH nor PCS required
+heartbeat:
+heartbeat: You might also want to install cluster-glue, heartbeat,
+heartbeat: resource-agents, fence-agents.
+heartbeat:
+heartbeat: